var initpage;
var sbqDate = ''
var prefix = "";
$(function () {
  if (config.environmental == 'test' || config.environmental =='preProduce') {
    prefix = "/web";
  } else if (config.environmental == 'production') {
    prefix = "/web/online";
  } 
  showLoading();
  getInitTable();
})

function getInitTable() {
  $.ajax({
    type: "post",
    url: config.url + "/online/declare/index",
    dataType: "json", // 请求方式为jsonp
    // async: false,
    data: {
      djxh: getUrlParam("djxh"),
      token: getUrlParam("token"),
      sbsq: "",
      pzzlDm: getUrlParam("pzzlDm"),
    },
    // beforeSend:function(){
    //   myAlert("提示", "正在获取初始化信息", "确定")
    // },
    success: function (data) { //客户端jquery预先定义好的callback函数，成功获取跨域服务器上的json数据后，会动态执行这个callback函数
      hideLoading();
      //el表达式变jqa
      // $("#token").attr("value","");
      if (data.success) {
        if (data.bean.url == "error.jsp") {
          myAlert("提示", data.bean.errorInfo, "确定")
          // window.location.href = "/jsp/error/index.html?falg="+param;
          return
        }
      }

      var companyInfo = data;
      if (companyInfo.success) {
        config.value = companyInfo.bean.value
        companyInfo.bean.config = config
        companyInfo.bean.return = true; /* @Author ygy @Date 10:12 2020/7/8 @Description 前端判断接口成功返回数据标记用于区分是否执行初始化table方法*/
        config.return = true;
        initpage = initPage(companyInfo.bean);
      } else {
        hideLoading();
        if (data.errmsg != undefined) {
          alertWarning(data.errmsg);
        } else {
          alertWarning(data.returnMessage);
        }
        if (!companyInfo.bean) {
          companyInfo.bean = {};
          companyInfo.bean.djxh = getUrlParam("djxh");
          companyInfo.bean.return = false;
        }
        companyInfo.bean.config = config
        initpage = initPage(companyInfo.bean);
        // 弹出错误对话框
      }
      $("#getInputValue").on("focus", function () {
        WdatePicker({
          isShowClear: false,
          dateFmt: 'yyyy-MM',
          onpicking: function (dp) {

            initpage.changeDate(this, dp);
          }
        });
      });
    },
    error: function (xhr) {
      hideLoading();
      //jsonp 方式此方法不被触发
      console.log("=======error======================")
    }
  })
}
/**
 * 按期申报填报列表页控制脚本
 *
 * @author 于广洋
 * @modify 王雷
 */
// -------------------------------
/**
 * 绘制税种填报页面
 *
 * @param {*} companyInfo
 */
function initPage(companyInfo) {
  getIEVersion();
  localStorage.setItem("cancellation", null);
  var companyInfo = companyInfo;
  var djxh = companyInfo.djxh;
  var nowdate = ""; // 存储当前选择的时间框;
  var submitData
  /**
   * 展示税种申报信息
   */
  var showTax = function (taxInfo) {
    if (taxInfo.length > 0) {
      var xgmData = [];
      for (var i = 0; i < taxInfo.length; i++) {
        if (taxInfo[i].sbrq) {
          taxInfo[i].sbrq = tool.formatDate(taxInfo[i].sbrq.split(" ")[0]);
        }
        if (taxInfo[i].bblxDm == '10102') {
          xgmData.push(taxInfo[i])
        }
      }
      taxInfo = xgmData
    }
    var id = "#taxGrid";
    var buttonHtml = "引导式申报";
    var order = ["pzzlMc", "djxh", "sssqQ", "sssqZ", "sbrq", "do"];
    var promptStatement = "";
    var headerList = [{
      name: "序号",
      width: "5%"
    }, {
      name: "申报表",
      width: "40%"
    },  {
      name: "登记序号",
      width: "15%"
    }, {
      name: "税款所属期起",
      width: "10%"
    }, {
      name: "税款所属期止",
      width: "10%"
    }, {
      name: "申报日期",
      width: "10%"
    }, {
      name: "操作",
      width: "10%"
    }];
    //渲染表
    getTableDeclaration(id, order, headerList, taxInfo, buttonHtml, promptStatement)
  };
  /**
   * 税务申报table渲染
   * @param {*} id
   * @param {*} order
   * @param {*} headerList
   * @param {*} ddt
   * @param {*} buttonHtml
   */
  var getTableDeclaration = function (id, order, headerList, ddt, buttonHtml, promptStatement) {
    var tableObj = {
      id: id, //tabel父元素的id
      autoHeight: ddt.length > 0 ? 10 : "",
      containerWidth: "99%", //table占父元素的百分比
      autoHeight: ddt.length > 0 ? 10 : "", // 默认10行
      order: order, //数据按照什么顺序排序  1.do为是否保函操作 2.序号列会自动添加不需要写
      onlyId: "uuId", //数据的唯一标识
      height: "320", //表格的高度
      buttonHeight: "", //表格的高度
      buttonHtml: buttonHtml, //按钮里的字
      headerList: headerList, //表头名字及占比，顺序与order对应
      promptStatement: promptStatement, // 没有数据时默认提示
      data: {
        page: "1",
        pageSize: ddt.length
      },
      jsonReady: ddt,
      callback: function (data, node) {
        data.operateType = '3';
        data.sbbz = '3';
        data.value = config.value;
        data.openType = 'xgmyds';
        if (data.sbzt == "Y") {
          myAlert("提示", "当前申报表已经申报", "确定")
          return false;
        }
        if (data.sourceFlag == "ssfwpt_sbzj") {
          window.pzzlData = data;

          var openTable = data
          openTable.bbDm = '10102_090'
          // openTable(data);

          var sbzjKbData = { // 税表组件 开表参数
            showHeader: true,
            bbDmVersion: '10102_090_10',
            valueTakingMethod: 'ajax', // 提取数据方式控制  ajax 请求后台  cache 取浏览器缓存  ""不许要请求后台   key值为allParam
            sksssjq: '',
            sksssjz: '',
            requestRarameters: {}, // 这里是对象
            requestAddress: {
              saveSbbInfoAddress: '/online/dataCenter/saveSbbInfo',
              selectSbbInfoAddress: '/online/zxtb/openTable',
            }, //存放接口地址
            readOnly: false,
            getCshBtn: false,
            getBjBtn: false,
            returnBtn: true,
            pdfBtn: false,
            printBtn: false,
            saveBtn: false,
            hideSaveData: false, //用于其他平台隐藏式开表保存数据
            replaceBtn: false,
            deleteBtn: false,
            getOtherData: false,
            formSaveData: false,
            disableBtn: {
              disSave: false,
              disReplace: false
            },
            openMode: {
              flag: '3'
            }
          }
          sbzjKbData.requestRarameters = openTable;
          var openUrl = config.taxFormComponent + JSON.stringify(sbzjKbData) + '&random=' + Math.random() + '#/' + sbzjKbData.bbDmVersion
          window.open(openUrl, '_blank');
        } else {
          data.djxh = companyInfo.djxh;
          data.iszzsybjc = companyInfo.iszzsybjc; // 一表申报代码
          data.nsrsbh = companyInfo.nsrsbh; // 那随人识别号
          data.nssbq = nowdate;
          data.checkTime = false;
          if (data.pzzlDm === '11602') {
            var List = companyInfo.taxInfos.filter(function (item) {
              return item.pzzlDm == '10101' || item.pzzlDm == '10102'
            })
            if (List.length === 0) {
              data.checkTime = true;
            }
            for (var i = 0; i < List.length; i++) {
              if (List[i].sssqQ !== data.sssqQ || List[i].sssqZ !== data.sssqZ) {
                data.checkTime = true;
                break;
              }
            }
          }
          submitData = data;
          if (node.context.innerText == "填写申报表" && companyInfo.iszzsybjc == "01" && data.pzzlDm == "10101") {
            // if(node.context.innerText=="填写申报表"){
            initpage.declarationMethod('N')
          } else {
            declarationMethod("N")
          }
        }
      } //点击按钮后的回调函数
    };
    var object = tool.tableCreate(tableObj);
    //        object.jsonReadyTo(ddt, { page: "1", pageSize: ddt.length });
  };

  /**
   * 税务申报 初始化数据获取
   * @param {*} mydate
   */
  //地址
  //http://sbjs.tjsat.gov.cn:18090
  //http://localhost:7070
  var url;
  if (companyInfo) {
    url = companyInfo.config.url;
  }
  var getTaxDeclaration = function (date, type, refreshSbzt) {
    // TODO 开始加载等待动画
    showLoading();
    var param = {
      djxh: djxh,
      operateType: companyInfo.operateType,
      sbsq: date,
      isFresh: type.toUpperCase() == "Y",
      pzzlDm: companyInfo.pzzlDm,
      refreshSbzt: refreshSbzt
    }
    $.ajax({
      url: url + "/online/declare/getPzzlList",
      data: param,
      type: "POST",
      dataType: "JSON",
      // beforeSend:function(){
      //   myAlert("提示", "正在获取初始化信息", "确定")
      // },
    }).done(function (data) {
      if (data.success) {
        zjhm = data.bean.zjhm
        if (data.bean.url == "error.jsp") {
          myAlert("提示", data.bean.errorInfo, "确定")
          return
        }
        drawGrid(data.bean);
        companyInfo = data.bean;
        config.value = companyInfo.value;
        if (type == 'Y') {
          myAlert("提示", "重置清册成功", "确定")
        }
      } else {
        if (data.errmsg != undefined) {
          alertWarning(data.errmsg);
        } else {
          alertWarning(data.returnMessage);
        }
      }
    }).always(function (data) {
      hideLoading();
    });
  };
  /**
   * 隐藏modal
   */
  var closeModal = function () {
    $('#ybName').html("");
    $('#dName').html("");
    $('#myMask').hide();
    $('#myModal').hide();
  }

  var drawGrid = function (bean) {
    //两个表合成一个表
    $.each(bean.financialInfos, function (i, item) {
      bean.taxInfos.push(item);
    });
    if (bean.taxInfos.length == 0) {
      showTax(bean.taxInfos);
      alertInfo("税费申报暂无数据");
    } else {
      showTax(bean.taxInfos);
    }
  };

  /**
   * 日期改变时触发
   * N 非强制刷新
   * @param {*} obj
   * @param {*} dp
   */
  var changeDate = function (obj, dp) {
    date = dp.cal.getNewDateStr();
    nowdate = date; // 给缓存时间赋值
    // 加了一个延时，时间改变后时间框没有收起隐藏就加载数据，没有找到好的解决办法，暂时用延时处理
    sbqDate = date
    setTimeout(function () {
      getTaxDeclaration(date, "N", '1');
    }, 50);
  };

  var refresh = function () {
    myConfirm("消息", "您确定需要重置申报清册吗？点击确定继续", "确定", "取消", function () {
      getTaxDeclaration(nowdate, "Y", '1');
    });
  };
  //申报方式 当iszzsybjc=01同时pzzlDm=010101时，调用改方法
  var declarationMethod = function (statu) {
    submitData.ybjcState = statu;
    submitData.value = config.value;
    //需要判断在线还是税表的开关
    if (submitData.sourceFlag == "ssfwpt_sbzj") {
      window.mlistener = {
        selectRowData: {},
      };
      submitData.fillingFlag = "normal" // 填报标记
      submitData.saveUserId = "zxtb"; // 用户id
      window.mlistener.selectRowData = submitData;
      Object.defineProperty(mlistener, 'returnSelectRowData', {
        set: function (val) {
          setTimeout(function () {
            getTaxDeclaration(sbqDate, "N", '2');
          }, 1000);
        }
      })
    } else {
      //"ssfwpt_zxtb"
      // var form = $("#changeForm");
      // form.find("#changeForm_data").val(JSON.stringify(submitData));
      // form.submit();
      showLoading()
      var falg = "declare";
      $.ajax({
        type: "POST",
        url: url + "/online/declare/toPzzl",
        dataType: "json", // 请求方式为jsonp
        data: {
          data: JSON.stringify(submitData)
        },
        success: function (data) {
          hideLoading()
          if (data.code == 99 || data.code == "99") {
            if (data.errmsg != undefined) {
              alertWarning(data.errmsg);
            } else {
              alertWarning(data.returnMessage);
            }
            return false
          }
          window.taxInfo = JSON.stringify(submitData);
          localStorage.setItem("data", JSON.stringify(submitData));
          if (data.url == "edit.jsp") {
            submitData.flag = true;
            submitData.encryptKey = config.value;
            var url = config.spreadUrl + "/online_report/declare/toPzzl?falg=" + falg
            var form = $("#changeForm");
            form.attr('action', url); //通过jquery为action属性赋值
            form.find("#changeForm_data").val(JSON.stringify(submitData));
            form.submit();

          }

        },
        error: function (xhr) {
          //jsonp 方式此方法不被触发
          if (data.returnMessage == undefined) {
            if (data.returnMessage == undefined) {
              alertWarning(data.errmsg);
            } else {
              alertWarning("程序错误，请联系管理员！");
            }
          } else {
            alertWarning(data.returnMessage);
          }
          hideLoading()
          console.log("=======error======================")
        }
      })

      closeModal();
    }
  }
  /**
   * 重置调用方法
   * @param {} params
   */
  $("#reset,#reset1").on("click", refresh);
  $("#goRecord").click(function () {
    //TODO 调用备案接口
  });
  // 格式化后台返回的时间
  if (companyInfo.config.return) {
    $("#getInputValue").val(tool.formatDate(companyInfo.sbsq));
    nowdate = companyInfo.sbsq;
    drawGrid(companyInfo);
  }
  //页面出现滚动条，监听滚动条变化将高赋值给模态框
  window.onscroll = function () {
    $("#myModal").css("top", $(document).scrollTop() + 235);
  }
  var sbzjKbData = { // 税表组件 开表参数
    showHeader: true,
    bbDmVersion: "",
    valueTakingMethod: "ajax", // 提取数据方式控制  ajax 请求后台  cache 取浏览器缓存  ""不许要请求后台   key值为allParam
    sksssjq: "",
    sksssjz: "",
    requestRarameters: {}, // 这里是对象
    requestAddress: {
      saveSbbInfoAddress: "/online/dataCenter/saveSbbInfo",
      selectSbbInfoAddress: "/online/zxtb/openTable",
      openTabUrl: prefix + config.ssfwptPage,
    }, //存放接口地址
    readOnly: false,
    getCshBtn: false,
    getBjBtn: false,
    returnBtn: true,
    pdfBtn: false,
    printBtn: false,
    saveBtn: true,
    hideSaveData: false, //用于其他平台隐藏式开表保存数据
    replaceBtn: false,
    deleteBtn: false,
    getOtherData: false,
    formSaveData: false,
    disableBtn: {
      disSave: false,
      disReplace: false
    },
    openMode: {
      flag: '3'
    }
  }
  var openTable = function (openData) {
    $.ajax({
      type: "post",
      url: config.url + "/online/zxtb/openTable",
      dataType: "json", // 请求方式为jsonp
      // async: false,
      data: openData,
      // beforeSend:function(){
      //   myAlert("提示", "正在获取初始化信息", "确定")
      // },
      success: function (data) { //客户端jquery预先定义好的callback函数，成功获取跨域服务器上的json数据后，会动态执行这个callback函数
        hideLoading();
        var bblxHeader = data.content.bblxHeader
        // var bbDmVersion = data.content.bblxHeader.bbDm+'_'+data.content.bblxHeader.versionNumber
        var bbDmVersion = '10102_090_10';
        sbzjKbData.bbDmVersion = bbDmVersion;
        sbzjKbData.sksssjq = bblxHeader.sksssjq;
        sbzjKbData.sksssjz = bblxHeader.sksssjz;
        if (data.content.data.length == 0) {
          data.content.data.push({
            header: bblxHeader,
            pageData: ""
          })
        }
        window.allParam = data.content;
        window.pzzlData = openData;
        window.mlistener = {
          selectRowData: {},
        };
        bblxHeader.fillingFlag = "normal" // 填报标记
        bblxHeader.saveUserId = "zxtb"; // 用户id
        sbzjKbData.requestRarameters = bblxHeader
        var openUrl = config.taxFormComponent + JSON.stringify(sbzjKbData) + '&random=' + Math.random() + '#/' + bbDmVersion
        window.open(openUrl, '_blank');

      },
      error: function (xhr) {
        hideLoading();
        //jsonp 方式此方法不被触发
        console.log("=======error======================")
      }
    })
  }

  return {
    changeDate: changeDate,
    reset: reset,
    declarationMethod: declarationMethod,
    closeModal: closeModal
  }
}